// SBitmapFont.cpp: Implementierung der Klasse SBitmapFont.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://stonemaster.port5.com
//////////////////////////////////////////////////////////////////////

#include "SBitmapFont.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SBitmapFont::SBitmapFont()
{
	widths = new int[256];
}

SBitmapFont::~SBitmapFont()
{
	delete[] widths;
}

bool SBitmapFont::createFont(HDC hDC, const char *fontname, int height, SFontAttri attributes)
{
	HFONT font;

	listBase = glGenLists(256);

	if (!listBase)
	{
		return false;
	}
	
	font = CreateFont(height,0,0,0,attributes.bold,
		attributes.italic,attributes.underline,FALSE,ANSI_CHARSET,
		OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,
		FF_DONTCARE | DEFAULT_PITCH,fontname);

	SelectObject(hDC,font);

	wglUseFontBitmaps(hDC,0,256,listBase);

	GetCharWidth(hDC,0,255,widths);

	return true;
}

void SBitmapFont::drawText(SAlign alignment , const char *string, ...)
{
	va_list argList;
	char text[256];
	int length = 0;

	if (!listBase || !string)
	{
		return;
	}

	va_start(argList,string);
		vsprintf(text,string,argList);
	va_end(argList);

	for (int i = 0; i < strlen(text); i += 1)
	{
		length += widths[text[i]];
	}

	switch (alignment)
	{
	case RIGHT:
		glBitmap(0,0,0,0,-length,0,NULL);
		break;
	case CENTER:
		glBitmap(0,0,0,0,-length/2,0,NULL);
		break;
	}

	glPushAttrib(GL_LIST_BIT);
	glListBase(listBase);
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
	glPopAttrib();
}
